> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Editors

> Lists all available code editors, optionally filtered to those allowed in an organization.

`Unary` · [`Editors`](/docs/api-reference/generated/editor/overview)

Lists all available code editors, optionally filtered to those allowed in an organization.

Use this method to:

* View supported editors
* Get editor capabilities
* Browse editor options
* Check editor availability

### Examples

* List editors:

  Shows all available editors with pagination.

  ```yaml theme={null}
  pagination:
    pageSize: 20
  ```

* List editors available to the organization:

  Shows all available editors that are allowed by the policies enforced in the organization with pagination.

  ```yaml theme={null}
  pagination:
    pageSize: 20
  filter:
    allowedByPolicy: true
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.EditorService/ListEditors
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.EditorService/ListEditors" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "pagination": {
      "pageSize": 1
    }
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.editor_pb2 as editor_pb2
  import gitpod.v1.pagination_pb2 as pagination_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = editor_pb2.ListEditorsRequest(
      pagination=pagination_pb2.PaginationRequest(
          page_size=1,
      ),
  )
  response = ona.services.editor.list_editors(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { ListEditorsRequestSchema } from "@gitpod/sdk/gitpod/v1/editor_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(ListEditorsRequestSchema, {
      pagination: {
        pageSize: 1,
      },
    });
    const response = await ona.services.editor.listEditors(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.ListEditorsRequest{
  		Pagination: &gitpodpb.PaginationRequest{
  			PageSize: 1,
  		},
  	})
  	response, err := ona.Services.Editor.ListEditors(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "pagination": {
      "pageSize": 1
    }
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.ListEditorsRequest`

| Field        | Type                                                    | Required | Description                                                         |
| ------------ | ------------------------------------------------------- | -------- | ------------------------------------------------------------------- |
| `pagination` | [PaginationRequest](#type-gitpod-v1-pagination-request) | No       | pagination contains the pagination options for listing environments |
| `filter`     | [Filter](#type-gitpod-v1-list-editors-request-filter)   | No       | filter contains the filter options for listing editors              |

## Response

`gitpod.v1.ListEditorsResponse`

| Field        | Type                                                      | Required | Description                                                         |
| ------------ | --------------------------------------------------------- | -------- | ------------------------------------------------------------------- |
| `editors`    | array of [Editor](#type-gitpod-v1-editor)                 | Yes      | editors contains the list of editors Constraints: `required=true`.  |
| `pagination` | [PaginationResponse](#type-gitpod-v1-pagination-response) | No       | pagination contains the pagination options for listing environments |

## Related types

<a id="type-gitpod-v1-editor" />

<Accordion title="Editor">
  `gitpod.v1.Editor`

  | Field                      | Type                                                     | Required | Description                                                      |
  | -------------------------- | -------------------------------------------------------- | -------- | ---------------------------------------------------------------- |
  | `id`                       | string                                                   | Yes      | Constraints: `required=true, string.uuid=true`.                  |
  | `name`                     | string                                                   | Yes      | Constraints: `required=true`.                                    |
  | `shortDescription`         | string                                                   | No       |                                                                  |
  | `installationInstructions` | string                                                   | Yes      | Constraints: `required=true`.                                    |
  | `iconUrl`                  | string                                                   | No       |                                                                  |
  | `urlTemplate`              | string                                                   | Yes      | Constraints: `required=true`.                                    |
  | `alias`                    | string                                                   | No       |                                                                  |
  | `versions`                 | array of [EditorVersion](#type-gitpod-v1-editor-version) | No       | versions contains the list of available versions for this editor |
</Accordion>

<a id="type-gitpod-v1-editor-version" />

<Accordion title="EditorVersion">
  `gitpod.v1.EditorVersion`

  | Field     | Type   | Required | Description                                                                                              |
  | --------- | ------ | -------- | -------------------------------------------------------------------------------------------------------- |
  | `version` | string | Yes      | version is the version string of the editor Examples for JetBrains: 2025.2 Constraints: `required=true`. |
</Accordion>

<a id="type-gitpod-v1-list-editors-request-filter" />

<Accordion title="Filter">
  `gitpod.v1.ListEditorsRequest.Filter`

  | Field             | Type    | Required | Description                                                                                                            |
  | ----------------- | ------- | -------- | ---------------------------------------------------------------------------------------------------------------------- |
  | `allowedByPolicy` | boolean | No       | allowed\_by\_policy filters the response to only editors that are allowed by the policies enforced in the organization |
</Accordion>

<a id="type-gitpod-v1-pagination-request" />

<Accordion title="PaginationRequest">
  `gitpod.v1.PaginationRequest`

  | Field      | Type    | Required | Description                                                                                                                              |
  | ---------- | ------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------- |
  | `pageSize` | integer | No       | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: `int32.gte=0, int32.lte=100`. |
  | `token`    | string  | No       | Token for the next set of results that was returned as next\_token of a PaginationResponse                                               |
</Accordion>

<a id="type-gitpod-v1-pagination-response" />

<Accordion title="PaginationResponse">
  `gitpod.v1.PaginationResponse`

  | Field       | Type   | Required | Description                                                                             |
  | ----------- | ------ | -------- | --------------------------------------------------------------------------------------- |
  | `nextToken` | string | No       | Token passed for retrieving the next set of results. Empty if there are no more results |
</Accordion>
